<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengerFlightDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPassengerFlightDetail
 * @subpackage Arrays
 */
class ArrayOfPassengerFlightDetail extends AbstractStructArrayBase
{
    /**
     * The PassengerFlightDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PassengerFlightDetail[]
     */
    public $PassengerFlightDetail;
    /**
     * Constructor method for ArrayOfPassengerFlightDetail
     * @uses ArrayOfPassengerFlightDetail::setPassengerFlightDetail()
     * @param \StructType\PassengerFlightDetail[] $passengerFlightDetail
     */
    public function __construct(array $passengerFlightDetail = array())
    {
        $this
            ->setPassengerFlightDetail($passengerFlightDetail);
    }
    /**
     * Get PassengerFlightDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PassengerFlightDetail[]|null
     */
    public function getPassengerFlightDetail()
    {
        return isset($this->PassengerFlightDetail) ? $this->PassengerFlightDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPassengerFlightDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPassengerFlightDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePassengerFlightDetailForArrayConstraintsFromSetPassengerFlightDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPassengerFlightDetailPassengerFlightDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengerFlightDetailPassengerFlightDetailItem instanceof \StructType\PassengerFlightDetail) {
                $invalidValues[] = is_object($arrayOfPassengerFlightDetailPassengerFlightDetailItem) ? get_class($arrayOfPassengerFlightDetailPassengerFlightDetailItem) : sprintf('%s(%s)', gettype($arrayOfPassengerFlightDetailPassengerFlightDetailItem), var_export($arrayOfPassengerFlightDetailPassengerFlightDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PassengerFlightDetail property can only contain items of type \StructType\PassengerFlightDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PassengerFlightDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerFlightDetail[] $passengerFlightDetail
     * @return \ArrayType\ArrayOfPassengerFlightDetail
     */
    public function setPassengerFlightDetail(array $passengerFlightDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($passengerFlightDetailArrayErrorMessage = self::validatePassengerFlightDetailForArrayConstraintsFromSetPassengerFlightDetail($passengerFlightDetail))) {
            throw new \InvalidArgumentException($passengerFlightDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($passengerFlightDetail) || (is_array($passengerFlightDetail) && empty($passengerFlightDetail))) {
            unset($this->PassengerFlightDetail);
        } else {
            $this->PassengerFlightDetail = $passengerFlightDetail;
        }
        return $this;
    }
    /**
     * Add item to PassengerFlightDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerFlightDetail $item
     * @return \ArrayType\ArrayOfPassengerFlightDetail
     */
    public function addToPassengerFlightDetail(\StructType\PassengerFlightDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PassengerFlightDetail) {
            throw new \InvalidArgumentException(sprintf('The PassengerFlightDetail property can only contain items of type \StructType\PassengerFlightDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PassengerFlightDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PassengerFlightDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PassengerFlightDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PassengerFlightDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PassengerFlightDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PassengerFlightDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengerFlightDetail
     */
    public function getAttributeName()
    {
        return 'PassengerFlightDetail';
    }
}
