<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengerFlightStatusDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPassengerFlightStatusDetail
 * @subpackage Arrays
 */
class ArrayOfPassengerFlightStatusDetail extends AbstractStructArrayBase
{
    /**
     * The PassengerFlightStatusDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PassengerFlightStatusDetail[]
     */
    public $PassengerFlightStatusDetail;
    /**
     * Constructor method for ArrayOfPassengerFlightStatusDetail
     * @uses ArrayOfPassengerFlightStatusDetail::setPassengerFlightStatusDetail()
     * @param \StructType\PassengerFlightStatusDetail[] $passengerFlightStatusDetail
     */
    public function __construct(array $passengerFlightStatusDetail = array())
    {
        $this
            ->setPassengerFlightStatusDetail($passengerFlightStatusDetail);
    }
    /**
     * Get PassengerFlightStatusDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PassengerFlightStatusDetail[]|null
     */
    public function getPassengerFlightStatusDetail()
    {
        return isset($this->PassengerFlightStatusDetail) ? $this->PassengerFlightStatusDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPassengerFlightStatusDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPassengerFlightStatusDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePassengerFlightStatusDetailForArrayConstraintsFromSetPassengerFlightStatusDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPassengerFlightStatusDetailPassengerFlightStatusDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengerFlightStatusDetailPassengerFlightStatusDetailItem instanceof \StructType\PassengerFlightStatusDetail) {
                $invalidValues[] = is_object($arrayOfPassengerFlightStatusDetailPassengerFlightStatusDetailItem) ? get_class($arrayOfPassengerFlightStatusDetailPassengerFlightStatusDetailItem) : sprintf('%s(%s)', gettype($arrayOfPassengerFlightStatusDetailPassengerFlightStatusDetailItem), var_export($arrayOfPassengerFlightStatusDetailPassengerFlightStatusDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PassengerFlightStatusDetail property can only contain items of type \StructType\PassengerFlightStatusDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PassengerFlightStatusDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerFlightStatusDetail[] $passengerFlightStatusDetail
     * @return \ArrayType\ArrayOfPassengerFlightStatusDetail
     */
    public function setPassengerFlightStatusDetail(array $passengerFlightStatusDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($passengerFlightStatusDetailArrayErrorMessage = self::validatePassengerFlightStatusDetailForArrayConstraintsFromSetPassengerFlightStatusDetail($passengerFlightStatusDetail))) {
            throw new \InvalidArgumentException($passengerFlightStatusDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($passengerFlightStatusDetail) || (is_array($passengerFlightStatusDetail) && empty($passengerFlightStatusDetail))) {
            unset($this->PassengerFlightStatusDetail);
        } else {
            $this->PassengerFlightStatusDetail = $passengerFlightStatusDetail;
        }
        return $this;
    }
    /**
     * Add item to PassengerFlightStatusDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerFlightStatusDetail $item
     * @return \ArrayType\ArrayOfPassengerFlightStatusDetail
     */
    public function addToPassengerFlightStatusDetail(\StructType\PassengerFlightStatusDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PassengerFlightStatusDetail) {
            throw new \InvalidArgumentException(sprintf('The PassengerFlightStatusDetail property can only contain items of type \StructType\PassengerFlightStatusDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PassengerFlightStatusDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PassengerFlightStatusDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PassengerFlightStatusDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PassengerFlightStatusDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PassengerFlightStatusDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PassengerFlightStatusDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengerFlightStatusDetail
     */
    public function getAttributeName()
    {
        return 'PassengerFlightStatusDetail';
    }
}
