<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Retrieve ServiceType
 * @subpackage Services
 */
class Retrieve extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named RetrieveSecureFlightStatus
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\RetrieveSecureFlightStatus $parameters
     * @return \StructType\RetrieveSecureFlightStatusResponse|bool
     */
    public function RetrieveSecureFlightStatus(\StructType\RetrieveSecureFlightStatus $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RetrieveSecureFlightStatus($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\RetrieveSecureFlightStatusResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
